﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using MovieCharacterFrenchFries.Data;

#nullable disable

namespace MovieCharacterFrenchFries.Migrations
{
    [DbContext(typeof(MovieCharacterFranchiseContext))]
    [Migration("20230227124518_create")]
    partial class create
    {
        /// <inheritdoc />
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "7.0.3")
                .HasAnnotation("Relational:MaxIdentifierLength", 128);

            SqlServerModelBuilderExtensions.UseIdentityColumns(modelBuilder);

            modelBuilder.Entity("CharacterMovie", b =>
                {
                    b.Property<int>("CharactersId")
                        .HasColumnType("int");

                    b.Property<int>("MoviesId")
                        .HasColumnType("int");

                    b.HasKey("CharactersId", "MoviesId");

                    b.HasIndex("MoviesId");

                    b.ToTable("CharacterMovie");
                });

            modelBuilder.Entity("MovieCharacterFrenchFries.Models.Character", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"));

                    b.Property<string>("Alias")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("imageUrl")
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("Id");

                    b.ToTable("Characters");
                });

            modelBuilder.Entity("MovieCharacterFrenchFries.Models.Franchise", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"));

                    b.Property<string>("Description")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("Id");

                    b.ToTable("Franchises");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            Description = "Uhm Robots kinda took over and humans are like totally mid atm, but this Neo dude is toatlly redpilling the matrix which is kinda based.",
                            Name = "The Matrix"
                        },
                        new
                        {
                            Id = 2,
                            Description = "Philosphical documantation of the human condition.",
                            Name = "Sharknado"
                        });
                });

            modelBuilder.Entity("MovieCharacterFrenchFries.Models.Movie", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"));

                    b.Property<string>("Director")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.Property<int>("FranchiseId")
                        .HasColumnType("int");

                    b.Property<string>("Genre")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("PosterUrl")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.Property<DateTime>("Release")
                        .HasColumnType("datetime2");

                    b.Property<string>("Title")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("TrailerUrl")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("Id");

                    b.HasIndex("FranchiseId");

                    b.ToTable("Movies");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            Director = "Nichlas Bay",
                            FranchiseId = 1,
                            Genre = "Fantasy",
                            PosterUrl = "https://wompampsupport.azureedge.net/fetchimage?siteId=7575&v=2&jpgQuality=100&width=700&url=https%3A%2F%2Fi.kym-cdn.com%2Fentries%2Ficons%2Ffacebook%2F000%2F014%2F409%2Fphteven.jpg",
                            Release = new DateTime(1999, 3, 24, 0, 0, 0, 0, DateTimeKind.Unspecified),
                            Title = "The Matrix",
                            TrailerUrl = "https://www.youtube.com/watch?v=xm3YgoEiEDc"
                        },
                        new
                        {
                            Id = 2,
                            Director = "Nichlas Bay",
                            FranchiseId = 1,
                            Genre = "Fantasy",
                            PosterUrl = "https://wompampsupport.azureedge.net/fetchimage?siteId=7575&v=2&jpgQuality=100&width=700&url=https%3A%2F%2Fi.kym-cdn.com%2Fentries%2Ficons%2Ffacebook%2F000%2F014%2F409%2Fphteven.jpg",
                            Release = new DateTime(2003, 3, 24, 0, 0, 0, 0, DateTimeKind.Unspecified),
                            Title = "The Matrix Reloaded",
                            TrailerUrl = "https://www.youtube.com/watch?v=xm3YgoEiEDc"
                        },
                        new
                        {
                            Id = 3,
                            Director = "Nichlas Bay",
                            FranchiseId = 1,
                            Genre = "Fantasy",
                            PosterUrl = "https://wompampsupport.azureedge.net/fetchimage?siteId=7575&v=2&jpgQuality=100&width=700&url=https%3A%2F%2Fi.kym-cdn.com%2Fentries%2Ficons%2Ffacebook%2F000%2F014%2F409%2Fphteven.jpg",
                            Release = new DateTime(2003, 3, 24, 0, 0, 0, 0, DateTimeKind.Unspecified),
                            Title = "The Matrix Revolutions",
                            TrailerUrl = "https://www.youtube.com/watch?v=xm3YgoEiEDc"
                        },
                        new
                        {
                            Id = 4,
                            Director = "Dean Schineder",
                            FranchiseId = 2,
                            Genre = "Documentary",
                            PosterUrl = "https://wompampsupport.azureedge.net/fetchimage?siteId=7575&v=2&jpgQuality=100&width=700&url=https%3A%2F%2Fi.kym-cdn.com%2Fentries%2Ficons%2Ffacebook%2F000%2F014%2F409%2Fphteven.jpg",
                            Release = new DateTime(2003, 3, 24, 0, 0, 0, 0, DateTimeKind.Unspecified),
                            Title = "Sharknado",
                            TrailerUrl = "https://www.youtube.com/watch?v=xm3YgoEiEDc"
                        },
                        new
                        {
                            Id = 5,
                            Director = "Dean Schineder",
                            FranchiseId = 2,
                            Genre = "Documentary",
                            PosterUrl = "https://wompampsupport.azureedge.net/fetchimage?siteId=7575&v=2&jpgQuality=100&width=700&url=https%3A%2F%2Fi.kym-cdn.com%2Fentries%2Ficons%2Ffacebook%2F000%2F014%2F409%2Fphteven.jpg",
                            Release = new DateTime(2003, 3, 24, 0, 0, 0, 0, DateTimeKind.Unspecified),
                            Title = "Sharknado 2: the feeding frenzy",
                            TrailerUrl = "https://www.youtube.com/watch?v=xm3YgoEiEDc"
                        });
                });

            modelBuilder.Entity("CharacterMovie", b =>
                {
                    b.HasOne("MovieCharacterFrenchFries.Models.Character", null)
                        .WithMany()
                        .HasForeignKey("CharactersId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("MovieCharacterFrenchFries.Models.Movie", null)
                        .WithMany()
                        .HasForeignKey("MoviesId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("MovieCharacterFrenchFries.Models.Movie", b =>
                {
                    b.HasOne("MovieCharacterFrenchFries.Models.Franchise", "Franchise")
                        .WithMany("Movies")
                        .HasForeignKey("FranchiseId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Franchise");
                });

            modelBuilder.Entity("MovieCharacterFrenchFries.Models.Franchise", b =>
                {
                    b.Navigation("Movies");
                });
#pragma warning restore 612, 618
        }
    }
}
